//
//
// @brief GridMapNXpeXgR[h
//        Obh}bv쐬C\.
//

#include <iostream>
#include <vector>
#include <fstream>
#include "CGridMap.h"
#include "CGridMapViewer.h"
using namespace RobotSystem;
using namespace std;

int main(){

	// Qf[^
	// Qf[^̓ǂݍ
	vector<Point2D<int>> obspos(796);
	int dummy(0);
	ifstream filein;
	filein.open("lrf_xyz.xls");
	if(!filein){
		std::cout << "file open error." << std::endl;
		return 1;
	}
	for(int i(0); i<769; ++i){
		filein >> obspos[i].x;
		filein >> obspos[i].y;
		filein >> dummy;
	}
	filein.close();

	// Obh}bvNX̃CX^X
	GridMapGenerator gmg(64, 48, 100); //100[mm]
	gmg.setVoteNum(5);
	GridMap<int, GridMapGenerator> gmap(&gmg);

	// {bg̈ʒuݒ
	Position2D<int> localpos(200, 2500);
	localpos.w.setDeg(10);

	// }bv쐬
	std::cout << "creating grid map" << std::ends;
	gmap.MapRenewal(localpos, obspos);
	std::cout << " ... done." << std::endl;

	// }bv擾
	int row(0), col(0), gridsize(0);
	gmap.getGridMapInformation(row, col, gridsize);
	std::cout << "map information is as follows." << std::endl;
	std::cout << "row size : "<< row << "\ncol size : "<< col << "\ngrid size : " << gridsize << std::endl;

	// }bvf[^擾
	RobotSystem::GridMapData<int> *ggmap(0);
	gmap.getCurrentMapData(ggmap);
	Position2D<int> rpos;
	gmap.getCurrentRobotPosition(rpos);

	// }bv\
	GridMapViewer gmv;
	gmv.setRobotSize(150);
	gmv.onGridLine(true);
	gmv.openWnd();
	std::cout << "push 'l' key to draw grid line on display." << std::endl;
	std::cout << "push 'o' key not to draw grid line on display." << std::endl;
	std::cout << "push 'q' key to quit program on display." << std::endl;
	while(1){
		char key(gmv.waitKeyDisplay(gmap, 10));
		if(key == 'q') break;
		else if(key == 'l') gmv.onGridLine(true);
		else if(key == 'o') gmv.onGridLine(false);
		gmap.MapRenewal(localpos, obspos);
	}

	return 0;
}
