#ifndef _CGRID_MAP_VIEWER_H_
#define _CGRID_MAP_VIEWER_H_

//
// CGridMapViewer.h
//
// @brief Obh}bv̕\NX OpenCVɈˑ
//

#include <bitset>
#include <cv.h>
#include <highgui.h>
#define _USE_MATH_DEFINES
#include <cmath>
#include "CGridMap.h"

//OpenCVp̃Cuݒ
//vOpenCV̊ݒ
#pragma comment(lib, "cv.lib")
#pragma comment(lib, "highgui.lib")
#pragma comment(lib, "cxcore.lib")

namespace RobotSystem{
	class ImageViewer{
	protected:
		// \EBhE
		string _wndname;
		// \摜obt@
		IplImage *_wndimg;
		int _wndw, _wndh;

	public:
		// RXgN^
		// @param wndname : \EBhE
		//        wndw : \EBhE̕
		//        wndh : \EBhE̍
		ImageViewer();
		ImageViewer(string wndname);
		ImageViewer(int wndw, int wndh);
		ImageViewer(string wndname, int wndw, int wndh);

		// fXgN^
		virtual ~ImageViewer();
			
		// \EBhẼI[v
		void openWnd();
		// \EBhẼN[Y
		void closeWnd();
		
		// 摜̍XV
		// * \摜̍XVsA\ʂɂ͔fȂ
		//       ʏ͂̊֐pɁAwaitKeyDisplay(img, msec)gp邱
		// *gp
		//         gmap.display(img);
		//         cvWaitKey(msec);
		//
		// @param img: \摜[bgr]
		void display();
		void display(void* img);

		// 摜̍XVƕ\
		// * OpenCVɈˑ\̂߁Å֐cvWaitKey(msec)
		//       gpꍇɂ͂̊֐pɁAdisplay()֐gp邱
		// *gp
		//         gmap.waitKeyDisplay(img, msec);
		//
		// @param msec : L[͑҂[msec]
		//        img : \摜[bgr]
		// @return ̓L[
		int waitKeyDisplay(int msec);
		int waitKeyDisplay(void* img, int msec);

		void setWndSize(int w, int h);
		void setWndName(string name);

	protected:
		// 摜XVƃL[
		int waitKey(int msec);
	};

	class GridMapViewer : public ImageViewer{
	protected:
		// }bv
		GridMap<int, GridMapGenerator> * _map;
		// Obh[pixel]
		int _gpixel;
		// {bga
		int _rsize;

		enum OPTION{
			GRIDLINE=0,
			OPTION_NUM    // IvV̌
		};
		std::bitset<OPTION_NUM> option_flag;

	public:
		// RXgN^
		// @param rsize : {bga[mm]
		GridMapViewer();
		GridMapViewer(int rsize);

		// fXgN^
		~GridMapViewer();

		// {bga̐ݒ
		// @param rsize : {bga[mm]
		void setRobotSize(int rsize);

		// IvVݒ
		// Obh̕`
		void onGridLine(bool on);

		// Obh}bv摜̍XV
		// * \摜̍XVsA\ʂɂ͔fȂ
		//       ʏ͂̊֐pɁAwaitKeyDisplay(map, msec)gp邱
		// *gp
		//         gmap.display(map);
		//         cvWaitKey(msec);
		//
		// @param map: Obh}bv
		virtual void display(GridMap<int, GridMapGenerator>& map);

		// Obh}bv摜̍XVƕ\
		// * OpenCVɈˑ\̂߁Å֐cvWaitKey(msec)
		//       gpꍇɂ͂̊֐pɁAdisplay(map)֐gp邱
		// *gp
		//         gmap.waitKeyDisplay(map, msec);
		//
		// @param msec : L[͑҂[msec]
		//        map : Obh}bv
		// @return ̓L[
		int waitKeyDisplay(GridMap<int, GridMapGenerator>& map, int msec);

	protected:
		// ̕`
		void drawAxis(int grow, int gcol);
		// {bg̕`
		void drawRobot(Position2D<int> rpos, int gsize);
		// Q̕`
		void drawObstacls(int gx, int gy);
	};

	/*
	class PGridMapViewer : public GridMapViewer{
	public:
		PGridMapViewer();
		~PGridMapViewer();

		void display(GridMap& map);
	};*/

	/*
		// Obh}bv̕ۑ
		// @param filenameFۑt@C
		void GridMap::SaveMap(std::string filename){
			std::ofstream ofs(filename.c_str());
			for(int x(0); x<_grow; ++x){
				for(int y(0); y<_gcol; ++y){
				ofs << _map[x][y] << "	";
			}
			ofs << std::endl;
		}*/
};


#endif //_CGRID_MAP_VIEWRE_H_