// -*-C++-*-
/*!
 * @file  MapControlSVC_impl.h
 * @brief Service implementation header of MapControl.idl
 *
 */

#include "MapControlSkel.h"

#ifndef MAPCONTROLSVC_IMPL_H
#define MAPCONTROLSVC_IMPL_H

#include "CGridMap.h"

/*!
 * @class MapControlSVC_impl
 * Example class implementing IDL interface MapControl
 */
class MapControlSVC_impl
 : public virtual POA_MapControl,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~MapControlSVC_impl();
   CORBA::LongSeq _map;
   int _mrow, _mcol, _mgsize;
   RobotSystem::Position2D<int> _rpos;
   RobotSystem::Point2D<int> _rgpos;

 public:
  /*!
   * @brief standard constructor
   */
   MapControlSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~MapControlSVC_impl();

   // attributes and operations
   CORBA::Long getMapSize(CORBA::Long& row, CORBA::Long& col, CORBA::Long& gridsize);
   CORBA::Long getMapData(CORBA::Any_OUT_arg data);
   CORBA::Long getRobotPosition(CORBA::Long& x, CORBA::Long& y, CORBA::Long& theta);
   CORBA::Long getRobotPositionOnGrid(CORBA::Long& row, CORBA::Long& col);

   // }bv𑗐Mpobt@ɃZbg
   void setMap(RobotSystem::GridMap<int, RobotSystem::GridMapGenerator>& map);

private:
	bool _lock;
public:
   // T[rX|[g֐̃K[h
	inline void lockService(){_lock =true;}
	inline void unlockService(){_lock =false;}
};



#endif // MAPCONTROLSVC_IMPL_H


