#include "CMobileRobotControl.h"

//
// CMobileRobotControl.cpp
//
// @author H.Takahashi, Arai Lab.,Osaka Univ.
// @brief UMLRT~hEFAɂ郂fx[X{bgVXeJ
//        t\tgEFA
//        ̃t@CŃr[SpMobileRobotControlNX̎
//        sĂB
//

// ۂߊ֐
inline int d2i(double v){
	if(v >= 0.0){
		v += 0.5;
	}else{
		v -= 0.5;
	}
	return (int)v;
}

//------------------------- MobileRobotControlNX̎ --------------------------
namespace RobotSystem{
//
// RXgN^
//
MobileRobotControl::MobileRobotControl()
:_init_argc(0),_funcflag(false){//, _limitRotVel(25), _limitStVel(45){
}

MobileRobotControl::MobileRobotControl(int argc, char *argv[])
:_init_argc(argc),_funcflag(false){
	// copy arguments
	_init_argv.resize(_init_argc);
	for(int i(0); i<_init_argc; ++i){
		_init_argv[i].assign(argv[i]);
	}

	setCoordinate(GLOBAL_COORDINATE);
}

//
// fXgN^
//
MobileRobotControl::~MobileRobotControl(){
	if(_run.isConnected()){Disconnect();}
}

void MobileRobotControl::setCmdArg(int argc, char *argv[]){
	while(_funcflag){ ; }
	_funcflag = true;

	// copy arguments
	_init_argc = argc;
	_init_argv.clear();
	_init_argv.resize(_init_argc);
	for(int i(0); i<_init_argc; ++i){
		_init_argv[i].assign(argv[i]);
	}

	_funcflag = false;
}

// servoCtrl
// @brief T[{
// @param on : T[{̃I(true)EIt(false)
void MobileRobotControl::servoCtrl(bool on){
	_run.servoCtrl(on);
}

//
// Stop
// @brief ~R}h̔s
//
void MobileRobotControl::Stop(){
	while(_funcflag){ ; }
	_funcflag = true;

	_run.stop();

	_funcflag = false;
}

void MobileRobotControl::setCoordinate(int coordinate){
	while(_funcflag){ ; }
	_funcflag = true;

	_coordinate = coordinate;

	_funcflag = false;
}

//
// FollowLine
// @brief Ǐ]
//        ̊֐͎w肵ʒu3[cm]ȓɋ߂Â܂returnȂ
// @param x : ʒuxW[mm]
//        y : ʒuyW[mm]
//        theta : ppx[deg]
// @return true(Ǐ]\), false(Ǐ]s\)
//
bool MobileRobotControl::FollowLine(int x, int y, int theta){
	while(_funcflag){ ; }
	_funcflag = true;

	// seting target position
	_path.x=x; _path.y=y; _path.zt=VXV::deg(theta);

	if(_coordinate){
		_path = convRobot2Global(_path);
	}

	// send follow command
	_run.followLine(_path);

	// wait
	int waitTime(0);    //[msec]
	int delayTime(100); //[msec]
	
	while(abs(_run.getLengthToLine(_path)) > 600){
		// waiting 100[msec]
		VXV::Delay(delayTime);
		waitTime+=delayTime;

		// if 1[sec] has passed, Beego is stopped.
		if(waitTime > 500){
			//Stop();
			break;
		}
	}

	_funcflag = false;

	return true;
}

//
// getLocalPosition
// @brief IhgɊÂȈʒu茋
// @param x : ȈʒuxW[mm]
//        y : ȈʒuyW[mm]
//        theta : Ȏppx[deg]
//
void MobileRobotControl::getLocalPosition(int &x, int &y, int &theta){
	while(_funcflag){ ; }
	_funcflag = true;

	// get local position from beego
	VXV::Position pos = _run.getLocalPosition();

	// return local position
	x = pos.x; y = pos.y; theta = pos.zt.to_deg();

	_funcflag = false;
}

//
// adjustLocalPosition
// @brief ȈʒuC
// @param x : CȈʒuxW[mm]
//        y : CȈʒuyW[mm]
//       theta : CȎppx[deg]
// @return true(ȈʒuC), false(ȈʒuCs)
//
bool MobileRobotControl::adjustLocalPosition(int x, int y, int theta){
	while(_funcflag){ ; }
	_funcflag = true;

	// set values
	VXV::Position pos(x, y, VXV::deg(theta));

	// adjust local position
	_run.adjustRunPosition(pos);

	_funcflag = false;
	return true;
}

//
// Connect
// @brief [^p{[hƂ̒ʐMm
// @return true(ڑ), false(ڑs)
//
bool MobileRobotControl::Connect(){
	while(_funcflag){ ; }
	_funcflag = true;

	char** argv;
	argv = new char*[_init_argc];
	for(int i(0); i<_init_argc; ++i){
		argv[i] = const_cast<char*>(_init_argv[i].c_str());
	}

	if(_run.connect( _init_argc, argv )<0){
		std::cout << "MobileRobotControl::Connect: " << _run.what() << std::endl;
	}

	delete [] argv;

	bool ret = _run.isConnected();
	if(ret) servoCtrl(true);

	_funcflag = false;

	return ret;
}

//
// Disconnect
// @brief [^p{[hƂ̒ʐMؒf
// @return true(ؒf), false(ؒfs)
//
bool MobileRobotControl::Disconnect(){
	while(_funcflag){ ; }
	_funcflag = true;

	servoCtrl(false);

	_run.disconnect();
	bool ret = !_run.isConnected();

	_funcflag = false;
	return ret;
}

void MobileRobotControl::setVelLimit(int straight, int rotate){
	//_limitStVel = straight;
	//_limitRotVel = rotate;
	_run.setStraightRefVel(straight);
	_run.setRotateRefVel(VXV::deg(rotate));
}

void MobileRobotControl::setCurveRadius(int cradius){
	_run.setCurveRadius(cradius);
}


VXV::Position MobileRobotControl::convRobot2Global(VXV::Position robot){
	VXV::Position ret;
	VXV::Position local = _run.getLocalPosition();
	ret.x =  d2i(robot.x*cos(local.zt.to_rad()) - robot.y*sin(local.zt.to_rad()) + local.x);
	ret.y =  d2i(robot.x*sin(local.zt.to_rad()) + robot.y*cos(local.zt.to_rad()) + local.y);
	ret.zt = local.zt + robot.zt;

	return ret;
}

VXV::Position MobileRobotControl::convGlobal2Robot(VXV::Position global){
	VXV::Position ret;
	VXV::Position local = _run.getLocalPosition();

	//
	//  cos sin (-cos*x-sin*y)
	// -sin cos (sin*x-cos*y)
	double theta(local.zt.to_rad());
	ret.x = d2i( global.x*cos(theta)+global.y*sin(theta)-local.x*cos(theta)-local.y*sin(theta));
	ret.y = d2i(-global.x*sin(theta)+global.y*cos(theta)+local.x*sin(theta)-local.y*cos(theta));
	ret.zt = global.zt - local.zt;

	return ret;
}


}; //namespace BEEGO
//-----------------------------------------------------------------------------------