// beegoeXgpvO

#include "CMobileRobotControl.h"
#include <iostream>
#include <cmath>
using namespace RobotSystem;

// _ƒ̋߂֐
double getLengthPointToLine(VXV::Position point, VXV::Position line){
	double a(tan(line.zt.to_rad())), b(-1.0), c(-line.x*tan(line.zt.to_rad())+line.y);
	return (abs(a*point.x+b*point.y+c)/sqrt(a*a+b*b));
}

int main(int argc, char* argv[]){
	std::cout << "##### Beego control test #####" << std::endl;
	//vmonitor::show();
	//MobileRobotControl beego;
	MobileRobotControl beego(argc, argv);
	beego.setCoordinate(ROBOT_COORDINATE);
	vmonitor::show();
	
	// connct to beego
	std::cout << "connecting to Beego" << std::endl;
	if(beego.Connect()){
		std::cout << "done." << std::endl;
	}else{
		std::cout << "failed." << std::endl;
	}

	// control beego
	while(1){
		std::cout << "########### push key. ###########" << std::endl;
		std::cout << "'q'(quit) 'a'(adjust position)\n'f'(follow line) 'g'(get local position) : " << std::ends;
		char c;
		std::cin >> c;
		
		// quit test
		if(c == 'q'){
			std::cout << "quit to control" << std::endl;
			break;
		}
		// test of [adjustLocalPosition]
		else if(c == 'a'){
			std::cout << "test of [adjustLocalPosition]" << std::endl;
			std::cout << "input x coordinate : " << std::ends;
			int posx(0);
			std::cin >> posx;

			std::cout << "input y coordinate : " << std::ends;
			int posy(0);
			std::cin >> posy;

			std::cout << "input theta[deg] : " << std::ends;
			int postheta(0);
			std::cin >> postheta;

			// adjust local position
			std::cout << "adjusting local position of Beego" << std::endl;
			if(beego.adjustLocalPosition(posx, posy, postheta)){
				std::cout << "done." << std::endl;
			}else{
				std::cout << "failed." << std::endl;
			}
		}
		// test of [FollowLine]
		else if(c == 'f'){
			std::cout << "test of [FollowLine]" << std::endl;
			// initialize path
			std::deque<VXV::Position> lines;
			lines.push_back(VXV::Position(0, 0, VXV::deg(-45))); //0
			lines.push_back(VXV::Position(1000, -1000, VXV::deg(90)));//1
			lines.push_back(VXV::Position(1000, 1000, VXV::deg(45)));//2
			lines.push_back(VXV::Position(2000, 2000, VXV::deg(-90)));//3
			lines.push_back(VXV::Position(2000, 0, VXV::deg(180)));//4
			lines.push_back(VXV::Position(0, 0, VXV::deg(180)));//5
			lines.push_back(VXV::Position(0, 0, VXV::deg(90)));

			// display path
			std::deque<VXV::Grid3D> draw_lines;
			draw_lines.assign(lines.begin(), lines.end());
			vmonitor::drawContLine(draw_lines, White);

			// follow path
			std::deque<VXV::Position>::iterator itrpath = lines.begin();
			while(itrpath+1 != lines.end()){
				std::cout << "following local path.  " << std::endl;

				// convert path
				*itrpath = beego.convGlobal2Robot(*itrpath);
				std::cout << "x." << (*itrpath).x << "[mm] y." << (*itrpath).y << "[mm] theta." << (*itrpath).zt.to_deg() << "[deg]" << std::endl;

				if(beego.FollowLine((*itrpath).x, (*itrpath).y, (*itrpath).zt.to_deg())){
					std::cout << "done." << std::endl;
				}else{
					std::cout << "failed." << std::endl;
				}

				++itrpath;
				while(1){
					VXV::Position nextpath = beego.convGlobal2Robot(*(itrpath));
					VXV::Position localpos(0, 0, VXV::deg(0));
					double len = getLengthPointToLine(localpos, nextpath);
					if(len<250){
						break;
					}
				}
			}
			while(1){
				VXV::Position nextpath = beego.convGlobal2Robot(*(itrpath));
				VXV::Position localpos(0, 0, VXV::deg(0));
				double len = getLengthPointToLine(localpos, nextpath);
				if(len<100){
					break;
				}
			}
			beego.Stop();

		// test of [getLocalPosition]
		}else if(c == 'g'){
			std::cout << "test of [getLocalPosition]" << std::endl;
			int posx(0), posy(0), postheta(0);
			beego.getLocalPosition(posx, posy, postheta);
			VXV::Direction dir=VXV::rad(postheta);
			std::cout << "current position of Beego is as follows." << std::endl;
			std::cout << "-------------------------------------------------------" << std::endl;
			std::cout << "x : " << posx << "[mm]" << std::endl;
			std::cout << "y : " << posy << "[mm]" << std::endl;
			std::cout << "theta : " << dir.to_deg() << "[deg]" << std::endl;
			std::cout << "-------------------------------------------------------" << std::endl;
		}
	}

	// disconnect to beego
	std::cout << "disconnecting to Beego" << std::endl;
	if(beego.Disconnect()){
		std::cout << "done." << std::endl;
	}else{
		std::cout << "failed." << std::endl;
	}

	return 0;
}