// -*-C++-*-
/*!
 * @file  LocomotionControlSVC_impl.h
 * @brief Service implementation header of LocomotionControl.idl
 *
 */

#include "LocomotionControlSkel.h"

#ifndef LOCOMOTIONCONTROLSVC_IMPL_H
#define LOCOMOTIONCONTROLSVC_IMPL_H

#include "CMobileRobotControl.h"

/*!
 * @class LocomotionControlSVC_impl
 * Example class implementing IDL interface LocomotionControl
 */
class LocomotionControlSVC_impl
 : public virtual POA_LocomotionControl,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~LocomotionControlSVC_impl();
   RobotSystem::MobileRobotControl* _robot;

 public:
  /*!
   * @brief standard constructor
   */
   LocomotionControlSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~LocomotionControlSVC_impl();

   // attributes and operations
   CORBA::Boolean followLine(CORBA::Long x, CORBA::Long y, CORBA::Long theta);
   CORBA::Boolean stop();

   inline void setRobotControl(RobotSystem::MobileRobotControl *robot){_robot = robot;}

};

/*!
 * @class LocomotionCorrectionSVC_impl
 * Example class implementing IDL interface LocomotionCorrection
 */
class LocomotionCorrectionSVC_impl
 : public virtual POA_LocomotionCorrection,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~LocomotionCorrectionSVC_impl();
   RobotSystem::MobileRobotControl* _robot;

 public:
  /*!
   * @brief standard constructor
   */
   LocomotionCorrectionSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~LocomotionCorrectionSVC_impl();

   // attributes and operations
   CORBA::Boolean adjustLocalPosition(CORBA::Long x, CORBA::Long y, CORBA::Long theta);

   inline void setRobotControl(RobotSystem::MobileRobotControl *robot){_robot = robot;}
};



#endif // LOCOMOTIONCONTROLSVC_IMPL_H
