#include "PositionSensor.h"
//
// CPositionSensor.cpp
//
// @author K.Ohara, Arai Lab.,Osaka Univ.
// @brief UMLRT~hEFAɂ郂fx[X{bgVXeJ
//        t\tgEFA
//        ̃t@CňʒuvZTłStarGazerp
//        PositionSensorNX̎sĂB
//

namespace RobotSystem{
//*********************************************************************
//Private Functions
//*********************************************************************


//*********************************************************************
//Public Functions
//*********************************************************************
//RXgN^
PositionSensor::PositionSensor(void){
	init_x     = 0;
	init_y	   = 0;
	init_theta = 0;
}

//fXgN^
PositionSensor::~PositionSensor(void){
}

//
//֐
//@param portname	: ڑCOM|[g(example: "COM1")
//       baudrate	: {[[g
//@return true(ڑ), false(ڑs)
//
bool PositionSensor::Connect(const char *portname, long baudrate){
	//w肵VA|[g֐ڑ
	if(!sc.Connect(portname,baudrate)){
		return false;
	}

	//ʒȕ
	ResetPosition();
	return true;
}

//I֐
void PositionSensor::Disconnect(){
	sc.Disconnect();
}

//
//ʒũZbg
//@return true(Zbg),false(Zbgs)
//
bool PositionSensor::ResetPosition(){
	double temp_x, temp_y, temp_theta;
	getLocalPosition(&temp_x,&temp_y,&temp_theta);

	//݈ʒuʒuɐݒ
	init_x += temp_x;
	init_y += temp_y;
	init_theta -= temp_theta;
	return true;
}

//
//ʒuf[^̊l
//
//@param x		: {bgXWiPʁFmmj
//       y		: {bgYWiPʁFmmj
//       theta	: {bǧX(PʁFDegree)
//@return true(l),false(ls)
//
bool PositionSensor::getLocalPosition(double *x, double *y, double *theta){
	char ReceiveData[50];
	char ReceiveDataTemp[50];
	int  length(0);

	//StarGazer̃f[^̎M
	while(true){	 
		int ReceiveBytes = sc.ReceiveMessage(ReceiveDataTemp,1);
		if(ReceiveBytes == 1){
			//StarGazerpPbg1ԍŏ̃f[^mF
			//ڍׂStarGazer̃}jAQ
			if(ReceiveDataTemp[0] == '~' || ReceiveData[0] == '~'){
				ReceiveData[length] = ReceiveDataTemp[0];
				length++;
			}
			else{
				length = 0;
			}
			//f[^̏I[o烋[v甲
			if(ReceiveDataTemp[0] == '`' && length > 1){
				break;
			}
		}
	}

	//M̉
	//MpPbg̗: ~^I+100|+101|+102|
	//ŏ̐(+100)		Fpx
	//Ԗڂ̐(+101)	FX
	//OԖڂ̐(+102)	FY
	string message;
	int mark_start, mark_end;
	char posi[100];
	

	for(int i(0);i<length;i++){
		message += ReceiveData[i];
	}

	//px̒o
	memset(posi,0,10);
	mark_start = 3;
	mark_end=message.find("|", mark_start);
	if(message[mark_start] == '+'){
		message.copy(posi,mark_end,mark_start+1);
	}
	else{
		message.copy(posi,mark_end,mark_start);
	}
	*theta = atof(posi) - init_theta;

	*theta*=-1.0;
	if(*theta<0){ *theta += 360.0; }
	if(*theta>=180.0){ *theta -= 360.0;}


	//Xʒu̒o
	memset(posi,0,10);
	mark_start = mark_end + 1;
	mark_end = message.find("|",mark_start);
	message.copy(posi, mark_end-mark_start);
	if(message[mark_start] == '+'){
		message.copy(posi,mark_end,mark_start+1);
	}
	else{
		message.copy(posi,mark_end,mark_start);
	}
	//cmmmւ̕Ԋ
	*x = atof(posi) * 10 - init_x;

	//Yʒu̒o
	memset(posi,0,10);
	mark_start = mark_end + 1;
	mark_end = message.find("|",mark_start);
	message.copy(posi, mark_end-mark_start);
	if(message[mark_start] == '+'){
		message.copy(posi,mark_end,mark_start+1);
	}
	else{
		message.copy(posi,mark_end,mark_start);
	}
	//cmmmւ̕ϊ
	*y = atof(posi) * 10 - init_y;

	std::cout<<"(X[mm],Y[mm],theta[degree])=("<<*x<<","<<*y<<","<<*theta<<")"<<std::endl;
	return true;	
}



};

