#include "RangeFinder.h"
//
// RangeFinder.cpp
//
// @author S.Yonesaka, Arai Lab.,Osaka Univ.
// @brief UMLRT~hEFAɂ郂fx[X{bgVXeJ
//        t\tgEFA
//        ̃t@CŖkzd@URG-04LXpRangeFinderNX̎
//        sĂB
//


//RXgN^
RangeFinder::RangeFinder():x_direc("right"){
}
//fXgN^
RangeFinder::~RangeFinder(){
}


//
// Connect
// @brief ݒ֐
// @param  portname: ڑCOM|[g(example: "COM1")
//         baudrate	: {[[g
// @return Nothing
//
void RangeFinder::Connect(const char *portname,long baudrate){

	ZeroMemory(&g_ReadOverlapped, sizeof(OVERLAPPED));		// Clear Overwrap structure
	ZeroMemory(&g_WriteOverlapped, sizeof(OVERLAPPED));

	CommOpen(portname,baudrate);							// Set and open communication port

	g_endFlag = 0;
}


//
// CommOpen
// @brief |[gݒ֐
// @param  portname: ڑCOM|[g(example: "COM1")
//         baudrate	: {[[g
// @return Nothing
//
void RangeFinder::CommOpen(const char *portname,long baudrate){
	DCB	dcb;
	BOOL 	retVal;

	g_ReadOverlapped.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	g_WriteOverlapped.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	// Open a cereal port ( using USB port number)
	g_commHandle = CreateFile(portname,					//Device Name
						GENERIC_READ | GENERIC_WRITE,	//Accessibility setting
						0,								//Shared method
						NULL,							//Security attribution(nomally, "0")
						OPEN_EXISTING,					//Opening Action
						FILE_ATTRIBUTE_NORMAL,			//Flag and attribution(Always "FILE_ATTRIBUTE_NORMAL")
						NULL);	

	// Setting of the connection
	dcb.DCBlength = sizeof(DCB);
	dcb.BaudRate = baudrate;
	dcb.fBinary = TRUE;
	dcb.fParity = FALSE;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fDsrSensitivity = FALSE;
	dcb.fTXContinueOnXoff = FALSE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.fErrorChar = FALSE;
	dcb.fNull = FALSE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.fAbortOnError = FALSE;
	dcb.fDummy2 = 0;
	dcb.wReserved = 0;
	dcb.XonLim = 0;
	dcb.XoffLim = 0;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	dcb.XonChar = 0;
	dcb.XoffChar = 0;
	dcb.ErrorChar = 0;
	dcb.EofChar = 0;
	dcb.EvtChar = 0;
	dcb.wReserved1 =0;

	retVal = SetCommState(g_commHandle,&dcb);		// Set DCB structure to the cereal port
	retVal = SetCommMask(g_commHandle,EV_RXCHAR);	// Set the reception ivent
	retVal = SetupComm(g_commHandle,0x1000,0x1000);	// Set the size of input/output buffer
    printf("//    Open URG port! \n\n");
}


//
// Disconnect
// @brief I֐
// @return Nothing
//
void RangeFinder::Disconnect()
{
	CloseHandle(g_commHandle);
	printf("URG End !!\n");
}


//
// getMeasuredData
// @brief Wf[^l֐
//@      eɂČvꂽf[^CZT̐ݒuʒu_Ƃ
//        WnɂWlƂĊl
// @param x : exW[mm]
//        y : eyW[mm]
//        z : ezW[mm]
// @return Nothing
//
void RangeFinder::getMeasuredData(long x[], long y[])
{
	MSG 	msg ; 						//Display buffer
	DWORD 	NumberOfByte;
	BYTE 	gCommand[] = "G00076800";	// G command character string
	BYTE 	txBuff[64];					//Output buffer
	BYTE 	*txBuffWork = txBuff;
 	int 	i,j,k=0;	

	DWORD 	Event,NumberOfBytes,Error;
	COMSTAT Comstat;
	BYTE 	lfCnt = 0;

	g_totalCnt = 0;

    float t,angle;       //Angle

	for(i = 0;i < 9;i++){
		*txBuffWork++ = gCommand[i];
	}

	*txBuffWork++ = 0xa;			// End character(line feed)

	WriteFile(g_commHandle,txBuff,txBuffWork - txBuff,&NumberOfByte,&g_WriteOverlapped);

	while(!g_endFlag){

		WaitCommEvent(g_commHandle,&Event,NULL);	// Confirm reception ivent
		
		if(Event &EV_RXCHAR){								// When the reception ivent starts
			ClearCommError(g_commHandle,&Error,&Comstat);	// Get the number of data size
			if(Comstat.cbInQue){                             // Read buffer(same size of reception size)
				if(!ReadFile(g_commHandle,rxBuffTmp,Comstat.cbInQue,&NumberOfBytes,&g_ReadOverlapped)){	// When the behavior haven't finished
					if(GetLastError() == ERROR_IO_PENDING){	// When there is no error
						GetOverlappedResult(g_commHandle,&g_ReadOverlapped,&NumberOfBytes,TRUE);	// Wait untill the behavior finished				
					}
				}
				for(i = 0;i < Comstat.cbInQue;i++){
					if(rxBuffTmp[i] == 0x0a){	// When "lf" is detected
						lfCnt++;
					}else{
						rxBuff[g_totalCnt++] = rxBuffTmp[i];
						lfCnt = 0;
					}
                       	
					if(lfCnt == 2)			// When "lf" is detected two times
					{
						lfCnt = 0;
						g_endFlag = 1;		// Connection Complete
						printf("M\n");
					}
				}
			}
		}	
	}

	g_endFlag = 0;

	for(j = 10;j < g_totalCnt;j+=2)
	{	// fR[hȂ狗i[
		g_distance[0][k++] = ((rxBuff[j] - 0x30) << 6) + (rxBuff[j+1] - 0x30);
	}
	g_totalCnt = 0;

	if(x_direc=="front"){ //XURG
		angle=0.0;
	}else{
		angle=M_PI/2;     //YURG
	}

	for(j = 0; j < 769; j++){
	    t=(-135.0+j*360.0/1024.0)*M_PI/180.0;
		x[j]=g_distance[0][j]*cos(t+angle);
		y[j]=g_distance[0][j]*sin(t+angle);
		printf("( x, y)=( %d[mm], %d[mm])\n", x[j],y[j]);
	}

}
